
#include "cgi.h"

int main() {
  cout<<"content-type: text/html\n\n";
  cout<<"<html><body><h1>TestCgi</h1>\n";

  cout<<"<h2>GET query</h2>\n"
    "<form action=testcgi.cgi method=GET>\n"
    "<input name=field1>\n"
    "<input name=test>\n"
    "<input type=submit value=submit>\n"
    "</form>\n";  
  cout<<"<h2>POST query</h2>\n"
    "<form action=testcgi.cgi method=POST>\n"
    "<input name=field1>\n"
    "<input name=test>\n"
    "<input type=submit value=submit>\n"
    "</form>\n";
  cout<<"<h2>multipart query</h2>\n"
    "<form action=testcgi.cgi method=POST enctype=\"multipart/form-data\">\n"
    "<input name=upload type=file>\n"
    "<input type=submit value=submit>\n"
    "</form>";
  cout<<"<h2>Results:</h2>\n";
  cout<<"<pre>\n";
  try {
    Cgi cgi;
    CgiItem item;
    int i=0;
    while (cgi.GetItem(item) && i<10) {
      ++i;
      cout<<"Item\n"
	"  name="<<item.name<<"\n"
	"  value_length="<<item.value_length<<"\n"
	"  filename="<<item.filename<<"\n";
      if (item.value.size()<80)
	cout<<"  value="<<item.value<<"\n\n";
      else {
	cout<<"  value.size="<<item.value.size()<<"\n";
	cout<<"  value="<<string(item.value,0,40)<<"\n[...]\n"
	    <<string(item.value,item.value.size()-40,item.value.size())
	    <<"\n\n";
      }
    }
  } catch (runtime_error e) {
    cout<<"errore: "<<e.what()<<"\n";
  }
  cout<<"</pre>\n";
}
