class StatusBar {
  static const int len=60;
public:
  StatusBar(int len): n(len), i(0) {write();};
  ~StatusBar() {newline();};
  void reset() {i=0;write();};
  void next() {
    ++i; 
    if (i%(1+n/100)==0)
      write();
  };
  void fill() {i=n; write();};
  void newline() const {
    cerr<<char(13);
    for (int j=0;j<len+2;++j)
      cerr<<" ";
    cerr<<char(13);
  };
  void write() const {
    static char fan[]="/-\\|";
    static int fanpos=0;
    cerr<<char(13)<<"[";
    int status=0;
    for (int j=0;j<len;j++) {
      if (status==0 && j*n >= i*len) status=1;
      if (status==0) {
	cerr<<"*";
      } else if (status==1) {
	cerr<<fan[fanpos++];
	fanpos%=4;
	status=2;
      } else {
	cerr<<".";
      }
    }
    cerr<<"]"<<char(13);
  };
private:
  int n;
  int i;
};
