#include "drawing.h"

void drawer::graph(const map<double,double> &g) {
  point last;
  for (map<double,double>::const_iterator i=g.begin();i!=g.end();++i) {
    point p=point(i->first,i->second);
    if (i!=g.begin()) line(last,p);
    last=p;
  }
};

void drawer::curve(const vector<point> &c) {
  point last;
  for (vector<point>::const_iterator i=c.begin();i!=c.end();++i) {
    if (i!=c.begin()) line(last,*i);
    last=*i;
  }
};

